###################################################
### chunk number 1: 
###################################################
options("digits"=4)
options("width"=80)


###################################################
### chunk number 2: 
###################################################
require(cem)
data(LeLonde)


###################################################
### chunk number 3: 
###################################################
Le <- data.frame(na.omit(LeLonde))


###################################################
### chunk number 4: 
###################################################
tr <- which(Le$treated==1)
ct <- which(Le$treated==0)
ntr <- length(tr)
nct <- length(ct)


###################################################
### chunk number 5: 
###################################################
mean(Le$re78[tr]) - mean(Le$re78[ct])


###################################################
### chunk number 6: 
###################################################
vars <- c("age", "education", "black", "married", "nodegree", "re74",
"re75", "hispanic", "u74", "u75","q1")


###################################################
### chunk number 7: 
###################################################
L1 <- L1.meas(Le$treated, Le[vars])$L1 


###################################################
### chunk number 8: 
###################################################
imbalance(group=Le$treated, data=Le[vars])


###################################################
### chunk number 9: 
###################################################
mat <- cem(treatment = "treated", data = Le, drop = "re78")


###################################################
### chunk number 10: 
###################################################
mat


###################################################
### chunk number 11: 
###################################################
q1.grp <- list(c("strongly agree", "agree"), c("neutral","no opinion"), c("strongly disagree","disagree"))


###################################################
### chunk number 12: 
###################################################
table(Le$education)


###################################################
### chunk number 13: 
###################################################
educut <- c(0, 6.5, 8.5, 12.5, 17)


###################################################
### chunk number 14: 
###################################################
mat1 <- cem(treatment = "treated", data = Le, drop = "re78", 
cutpoints = list(education=educut), grouping=list(q1.grp))
mat1


###################################################
### chunk number 15: 
###################################################
mat$breaks$education


###################################################
### chunk number 16: 
###################################################
mat1$breaks$education


###################################################
### chunk number 17: 
###################################################
cem("treated", Le, cutpoints = list(age=10), drop="re78", grouping=q1.grp)
cem("treated", Le, cutpoints = list(age=6), drop="re78", grouping=q1.grp)
cem("treated", Le, cutpoints = list(age=3), drop="re78", grouping=q1.grp)


###################################################
### chunk number 18: 
###################################################
tab <- relax.cem(mat, Le, depth=1, perc=0.3) 


###################################################
### chunk number 19: 
###################################################
pdf("coarsen1.pdf", width=9, height=6, pointsize=10)
plot(tab,perc=0.3)
invisible(dev.off())


###################################################
### chunk number 20: 
###################################################
plot(tab, group="1", perc=0.35,unique=TRUE)


###################################################
### chunk number 21: 
###################################################
pdf("coarsen2.pdf", width=9, height=6, pointsize=10)
plot(tab, group="1", perc=0.35,unique=TRUE)
invisible(dev.off())


###################################################
### chunk number 22: 
###################################################
mat <- cem(treatment="treated",data=Le, drop="re78")
mat
mat$k2k


###################################################
### chunk number 23: 
###################################################
mat2 <- k2k(mat, Le, "euclidean", 1)
mat2
mat2$k2k


###################################################
### chunk number 24: 
###################################################
est <- att(mat, re78 ~ treated, data = Le)
est


###################################################
### chunk number 25: 
###################################################
est2 <- att(mat, re78 ~ treated + re74 + re75, data = Le)
est2


###################################################
### chunk number 26: 
###################################################
mat3 <- cem("treated", LeLonde, drop="re78", cutpoints = mat$breaks, grouping=list(q1=q1.grp))
mat3


###################################################
### chunk number 27: 
###################################################
mat4 <- cem("treated", Le, drop="re78", cutpoints = mat$breaks, grouping=list(q1=q1.grp))
mat4


###################################################
### chunk number 28: 
###################################################
summary(LeLonde)


###################################################
### chunk number 29: 
###################################################
require(Amelia)
set.seed(123)
imputed <- amelia(LeLonde,noms=c("black","hispanic","treated","married","nodegree",
"u74","u75","q1"))[1:5]


###################################################
### chunk number 30: 
###################################################
mat2 <- cem("treated", datalist=imputed, drop="re78", data=LeLonde, grouping=list(q1=q1.grp))
mat2


###################################################
### chunk number 31: 
###################################################
out <- att(mat2, re78 ~ treated, data=imputed)
out


